/********************************************************************************
    startcodes - dumps position, id and bytes between start-codes
 ********************************************************************************
    LibVideoCoding - video coding library
    Copyright (C) 2002  Dirk Farin

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 ********************************************************************************/

#include <libvideocoding/fileio/inputstream_istr.hh>
#include <libvideocoding/mpeg2/syntax/system.hh>

#include <stdio.h>
#include <iostream>
#include <iomanip>
#include <fstream>
using namespace std;
using namespace videocoding;

int main()
{
  InputStream_IStream istr;
  istr.SetIStream(cin);

  ByteBuffer bb;

  while (!istr.IsEOF())
    {
      bb.Clear();

      cout << hex << setw(6) << setfill('0') << ((int)(istr.AskPosition())) << ": ";

      ReadUntilNextStartCode(bb, istr);

      if (bb.AskLength()>=4)
	{
	  cout << hex << ((int)(bb.AskData()[3])) << " " << dec << bb.AskLength() << endl;
	}
      else
	{
	  cout << "short package (" << bb.AskLength() << " bytes)\n";
	}

#if 0
      static int cnt=1;
      char buf[100];
      sprintf(buf,"x%03d.txt",cnt++);
      ofstream ostr(buf);
      for (int i=0;i<bb.AskLength();i++)
	ostr << bb.AskData()[i];
#endif
    }

  return 0;
}
