/********************************************************************************
    LibVideoCoding - video coding library
    Copyright (C) 2002  Dirk Farin

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 ********************************************************************************/

#include "libvideocoding/dct/fdct_mmx.hh"

extern "C" {
extern void fdct_mmx( videogfx::int16 * blk, videogfx::int16 * out );
}

namespace videocoding {

  void FDCTBlk_AccurateMMX16::CalcFDCT(DCTBlock_8x8& blk,const int16* in,int in_stride)
  {
    int16 inbuf[8*8];
    int16* p=inbuf;

    for (int y=0;y<8;y++)
      {
	const int16* inp = in+y*in_stride;

	p[0]=inp[0];
	p[1]=inp[1];
	p[2]=inp[2];
	p[3]=inp[3];
	p[4]=inp[4];
	p[5]=inp[5];
	p[6]=inp[6];
	p[7]=inp[7];

	p+=8;
      }

    fdct_mmx(inbuf,&blk.coeff[0][0]);
  }


  void FDCTBlk_AccurateMMX8::CalcFDCT(DCTBlock_8x8& blk,const uint8* in,int in_stride)
  {
    int16 inbuf[8*8];
    int16* p=inbuf;

    for (int y=0;y<8;y++)
      {
	const uint8* inp = in+y*in_stride;

	p[0]=inp[0];
	p[1]=inp[1];
	p[2]=inp[2];
	p[3]=inp[3];
	p[4]=inp[4];
	p[5]=inp[5];
	p[6]=inp[6];
	p[7]=inp[7];

	p+=8;
      }

    fdct_mmx(inbuf,&blk.coeff[0][0]);
  }

}
